//
//  BJPUAppearance.h
//  BJVideoPlayerUI
//
//  Created by DLM on 2017/4/26.
//
//

#import <Foundation/Foundation.h>
#import <BJLiveBase/BJLiveBase+UIKit.h>

static inline BOOL BJPUIsHorizontalUI(id<UITraitEnvironment> traitEnvironment) {
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
        UIInterfaceOrientation orientation = (UIInterfaceOrientation)UIDevice.currentDevice.orientation;
        if (@available(iOS 13.0, *)) {
            for (UIScene *scene in UIApplication.sharedApplication.connectedScenes) {
                if (scene.activationState == UISceneActivationStateForegroundActive) {
                    UIInterfaceOrientation sceneOrientation = bjl_as(scene, UIWindowScene).interfaceOrientation;
                    if (sceneOrientation != UIInterfaceOrientationUnknown) {
                        orientation = sceneOrientation;
                        break;
                    }
                }
            }
        }
        else {
            UIInterfaceOrientation statusBarOrientation = UIApplication.sharedApplication.statusBarOrientation;
            if (statusBarOrientation != UIInterfaceOrientationUnknown) {
                orientation = statusBarOrientation;
            }
        }
        return (orientation != UIInterfaceOrientationPortrait
                && orientation != UIInterfaceOrientationPortraitUpsideDown);
    }
    return !(traitEnvironment.traitCollection.horizontalSizeClass == UIUserInterfaceSizeClassCompact
             && traitEnvironment.traitCollection.verticalSizeClass == UIUserInterfaceSizeClassRegular);
}

@interface UIColor (BJPU)

+ (UIColor *)bjpu_colorWithHexString:(NSString *)color alpha:(CGFloat)alpha;

+ (UIColor *)bjpu_colorWithHexString:(NSString *)color;

+ (instancetype)bjpu_brandColor;

@end

@interface UIImage (BJPU)

+ (UIImage *)bjpu_imageNamed:(NSString *)name;

@end

@interface NSString (BJPU)

+ (NSString *)stringFromTimeInterval:(NSTimeInterval)interval;

+ (NSString *)stringFromTimeInterval:(NSTimeInterval)interval totalTimeInterval:(NSTimeInterval)total;
@end
