//
//  BJPUSignInModel.m
//  BJVideoPlayerUI
//
//  Created by ney on 2023/10/18.
//  Copyright © 2023 BaijiaYun. All rights reserved.
//

#import "BJPUSignInModel.h"

@interface BJPUSignInModel ()
@property (nonatomic, readwrite) NSTimeInterval timeOffset;
@property (nonatomic, copy, readwrite) NSString *title;
@property (nonatomic, copy, readwrite) NSString *titleIconURLString;
@property (nonatomic, copy, readwrite) NSString *message;
@property (nonatomic, copy, readwrite) NSString *buttonText;
@end

@implementation BJPUSignInModel
- (void)encodeWithCoder:(NSCoder *)aCoder {
    [self bjlyy_modelEncodeWithCoder:aCoder];
}
- (nullable instancetype)initWithCoder:(NSCoder *)aDecoder {
    self = [super init];
    return [self bjlyy_modelInitWithCoder:aDecoder];
}
- (id)copyWithZone:(nullable NSZone *)zone {
    return [self bjlyy_modelCopy];
}
- (NSUInteger)hash {
    return [self bjlyy_modelHash];
}
- (BOOL)isEqual:(id)object {
    return [self bjlyy_modelIsEqual:object];
}

+ (instancetype)modelWithTimeOffset:(NSTimeInterval)timeOffset
                              title:(NSString *)title
                               icon:(NSString *)icon
                            message:(NSString *)message
                         buttonText:(NSString *)buttonText {
    BJPUSignInModel *model = [[BJPUSignInModel alloc] init];
    model.timeOffset = timeOffset;
    model.title = title;
    model.titleIconURLString = icon;
    model.message = message;
    model.buttonText = buttonText;
    return model;
}
@end
